import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

import klassen.Buch;

public class FensterNeu extends JDialog {

	@FunctionalInterface
	public interface IEintrag
	{
		public void addBuch(String nummer, String titel, double preis, int anzahl, Buch.Art kategorie);
	}
	
	
	public IEintrag OnClick; 
	
	private final JPanel contentPanel = new JPanel();
	private JTextField txtNummer;
	private JTextField txtTitel;
	private JTextField txtPreis;
	private JTextField txtAnzahl;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			FensterNeu dialog = new FensterNeu();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public FensterNeu() {
		setBounds(100, 100, 450, 300);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblNewLabel = new JLabel("Nummer");
			lblNewLabel.setBounds(50, 11, 46, 14);
			contentPanel.add(lblNewLabel);
		}
		{
			JLabel lblNewLabel_1 = new JLabel("Titel");
			lblNewLabel_1.setBounds(50, 51, 46, 14);
			contentPanel.add(lblNewLabel_1);
		}
		{
			JLabel lblNewLabel_2 = new JLabel("Preis");
			lblNewLabel_2.setBounds(50, 101, 46, 14);
			contentPanel.add(lblNewLabel_2);
		}
		{
			JLabel lblNewLabel_3 = new JLabel("Anzahl");
			lblNewLabel_3.setBounds(50, 145, 46, 14);
			contentPanel.add(lblNewLabel_3);
		}
		{
			JLabel lblNewLabel_4 = new JLabel("Kategorie");
			lblNewLabel_4.setBounds(50, 203, 46, 14);
			contentPanel.add(lblNewLabel_4);
		}
		{
			txtNummer = new JTextField();
			txtNummer.setBounds(172, 8, 86, 20);
			contentPanel.add(txtNummer);
			txtNummer.setColumns(10);
		}
		{
			txtTitel = new JTextField();
			txtTitel.setBounds(172, 48, 86, 20);
			contentPanel.add(txtTitel);
			txtTitel.setColumns(10);
		}
		{
			txtPreis = new JTextField();
			txtPreis.setBounds(172, 98, 86, 20);
			contentPanel.add(txtPreis);
			txtPreis.setColumns(10);
		}
		{
			txtAnzahl = new JTextField();
			txtAnzahl.setBounds(172, 142, 86, 20);
			contentPanel.add(txtAnzahl);
			txtAnzahl.setColumns(10);
		}
		
			JComboBox comboBox = new JComboBox();
			comboBox.setBounds(172, 206, 86, 22);
			
			for(Buch.Art art: Buch.Art.values())
			{
				comboBox.addItem(art);
			}
			contentPanel.add(comboBox);
		
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						
						if(OnClick == null) return; 
						
						double pr = Double.parseDouble(txtPreis.getText());
						int anzahl = Integer.parseInt(txtPreis.getText());
						Buch.Art art = Buch.Art.valueOf(comboBox.getSelectedItem().toString());
						
						OnClick.addBuch(txtNummer.getText(), txtTitel.getText(), pr, anzahl, art);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						FensterNeu.this.setVisible(false);
						FensterNeu.this.dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

}
