import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.IOException;
import java.text.ParseException;
import java.util.Optional;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.table.DefaultTableModel;

import klassen.Buch;
import klassen.Buchliste;

import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.JButton;

public class Hauptfenster extends JFrame {

	private JPanel contentPane;
	private JTable table;
	private Buchliste bl; 
	private JTextField txtUmsatz;
	private JTextField txtSuche;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Hauptfenster frame = new Hauptfenster();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 * @throws ParseException 
	 * @throws IOException 
	 */
	public Hauptfenster() throws IOException, ParseException {
		bl = new Buchliste();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 805, 462);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 21, 769, 219);
		contentPane.add(scrollPane);
		
		table = new JTable();
		scrollPane.setViewportView(table);
		
		DefaultTableModel model = new DefaultTableModel();
		
		for(String col: Buch.getTitles())
		model.addColumn(col);
		
		for(Buch b:bl.getAll())
		{
			model.addRow(b.getData());
		}
		table.setModel(model);
		
		JLabel lblNewLabel = new JLabel("Umsatz");
		lblNewLabel.setBounds(82, 281, 46, 14);
		contentPane.add(lblNewLabel);
		
		JComboBox comboBox = new JComboBox();
		comboBox.setBounds(56, 306, 101, 22);
		contentPane.add(comboBox);
		
		txtUmsatz = new JTextField();
		txtUmsatz.setBounds(71, 354, 86, 20);
		contentPane.add(txtUmsatz);
		txtUmsatz.setColumns(10);
		
		JLabel lblNewLabel_1 = new JLabel("Suchen");
		lblNewLabel_1.setBounds(321, 281, 46, 14);
		contentPane.add(lblNewLabel_1);
		
		txtSuche = new JTextField();
		txtSuche.setBounds(297, 328, 86, 20);
		contentPane.add(txtSuche);
		txtSuche.setColumns(10);
		
		JButton btnNewButton = new JButton("Neues Buch");
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				FensterNeu fenster = new FensterNeu();
				fenster.OnClick = (nr, titel, pr, anzahl, art) -> {
					bl.eintragen(nr, titel, pr, anzahl, art);
					model.getDataVector().removeAllElements();
					for(Buch b: bl.getAll())
					{
						model.addRow(b.getData());
					}
				};
				fenster.setVisible(true);
			}
		});
		btnNewButton.setBounds(570, 306, 89, 23);
		contentPane.add(btnNewButton);
		
		comboBox.addItem("ALLE");
		for(Buch.Art art: Buch.Art.values())
		{
			comboBox.addItem(art);
		}
		
		comboBox.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				String text = comboBox.getSelectedItem().toString();
				
				model.getDataVector().removeAllElements();
				
				if(text.equals("ALLE"))
				{
					txtUmsatz.setText(bl.getUmsatz()+"");
					for(Buch b: bl.getAll())
					{
						model.addRow(b.getData());
					}
				}
				else
				{
					txtUmsatz.setText(bl.getUmsatz(Buch.Art.valueOf(text))+"");
					for(Buch b: bl.getAll(Buch.Art.valueOf(text)))
					{
						model.addRow(b.getData());
					}
				}
			}
			
		});
		
		//sortierte Anzeige 
		table.getTableHeader().addMouseListener(new MouseListener() {

			@Override
			public void mouseClicked(MouseEvent e) {
				// TODO Auto-generated method stub
				int col = table.columnAtPoint(e.getPoint());
				int row = table.rowAtPoint(e.getPoint());
				
				if(row != 0) return; 
				
				model.getDataVector().removeAllElements();
				
				if(col == 0)
				{
					for(Buch b: bl.sortieren("nummer"))
					{
						model.addRow(b.getData());
					}
				}
				else if(col == 2)
				{
					for(Buch b: bl.sortieren("preis"))
					{
						model.addRow(b.getData());
					}
				}
				else if(col == 4)
				{
					for(Buch b: bl.sortieren("kategorie"))
					{
						model.addRow(b.getData());
					}
				}
			}

			@Override
			public void mousePressed(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mouseReleased(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mouseEntered(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mouseExited(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
		});

		txtSuche.addKeyListener(new KeyListener() {

			@Override
			public void keyTyped(KeyEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void keyPressed(KeyEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void keyReleased(KeyEvent e) {
				// TODO Auto-generated method stub
				if(e.getKeyCode() == KeyEvent.VK_ENTER)
				{
					String nummer = txtSuche.getText();
					
					Optional<Buch> suche = bl.suchen(nummer);
					
					suche.ifPresent(b -> {
						model.getDataVector().removeAllElements();
						model.addRow(b.getData());
					});
				}
			}
			
		});
	}
}
